/***************************************************************************//**
*  \details    This driver will act as an etherbone slave on the host
*              and controls a wishbone master in the FPGA over PCIe
*
*  \author     Michael Reese
*
* *******************************************************************************/
#include<linux/kernel.h>
#include<linux/init.h>
#include<linux/module.h>
 
/*
** Module Init function
*/
static int __init ebs_wbm_pcie_init(void)
{
    printk(KERN_INFO "Simple kernel module doing nothing inserted successfully\n");
    return 0;
}
/*
** Module Exit function
*/
static void __exit ebs_wbm_pcie_exit(void)
{
    printk(KERN_INFO "Simple kernel module removed\n");
}
 
module_init(ebs_wbm_pcie_init);
module_exit(ebs_wbm_pcie_exit);
 
MODULE_LICENSE("GPL");
MODULE_AUTHOR("Michael Reese <m.reese@gsi.de>");
MODULE_DESCRIPTION("Etherbone slave that controls a wishbone master module on the FPGA via PCIe");
MODULE_VERSION("1:0.0");
