#ifndef EB_SLAVE_H_
#define EB_SLAVE_H_

#include <linux/types.h>

typedef 
enum {
	EB_SLAVE_IDLE               = 0,
	EB_SLAVE_MAGIC_FOUND        = 1,
	EB_SLAVE_EXPECT_RECORD      = 2,
	EB_SLAVE_HANDLE_WRITES_BASE = 3,
	EB_SLAVE_HANDLE_WRITES      = 4,
	EB_SLAVE_HANDLE_READS_BASE  = 5,
	EB_SLAVE_HANDLE_READS       = 6,
} EB_SLAVE_STATE;

typedef struct {
	/* set these function pointers */
	void     (*hw_write)(uint32_t addr, uint32_t data);
	uint32_t (*hw_read)(uint32_t addr);
	uint32_t (*hw_cfg_read)(uint32_t addr);
	/* internal */
	EB_SLAVE_STATE state;
	uint8_t BCA, RCA, RFF, CYC, WCA, WFF;
	uint8_t ByteEnable;
	uint8_t WCount, RCount;
	uint32_t BaseWriteAddr;
	uint32_t BaseRetAddr;
	uint32_t error_shift_register;
	uint32_t sdb_address;
	uint8_t input[4];
	uint8_t output[4];
} EbSlaveState;

void eb_slave_reset(EbSlaveState *eb);

/* data must point to a 4 byte wide etherbone request. 
   After the function returns *data will be overwritten  
   with the etherbone slave response to the request 
   */
void eb_slave_process(EbSlaveState *eb, uint8_t *data);

#endif

